---
title: RegExp.prototype.source
slug: Web/JavaScript/Reference/Global_Objects/RegExp/source
tags:
  - JavaScript
  - Property
  - Prototype
  - Reference
  - RegExp
  - Regular Expressions
---
<div>{{JSRef}}</div>

<p>The <strong><code>source</code></strong> property returns a {{jsxref("String")}} containing the source text of the regexp object, and it doesn't contain the two forward slashes on both sides and any flags.</p>

<div>{{EmbedInteractiveExample("pages/js/regexp-prototype-source.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<div>{{js_property_attributes(0, 0, 1)}}</div>

<h2 id="Examples">Examples</h2>

<h3 id="Using_source">Using source</h3>

<pre class="brush: js notranslate">var regex = /fooBar/ig;

console.log(regex.source); // "fooBar", doesn't contain /.../ and "ig".
</pre>

<h3 id="Empty_regular_expressions_and_escaping">Empty regular expressions and escaping</h3>

<p>Starting with ECMAScript 5, the <code>source</code> property no longer returns an empty string for empty regular expressions. Instead, the string <code>(?:)</code> is returned. In addition, line terminators (such as "\n") are escaped now.</p>

<pre class="brush: js notranslate">new RegExp().source; // "(?:)"

new RegExp('\n').source === '\n';  // true, prior to ES5
new RegExp('\n').source === '\\n'; // true, starting with ES5
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-get-regexp.prototype.source', 'RegExp.prototype.source')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.RegExp.source")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("RegExp.prototype.flags")}}</li>
</ul>
